/*
  Smoothing
 Folyamatosan kiolvassa az analóg bemenetet és a tömbben  eltárolt értékeket folyamatosan átlagolja.
 
 Áramkör:
 * Analóg szenzor az analóg 0 pinbe.
 
 Created 22 April 2007
 By David A. Mellis  <dam@mellis.org>
 modified 9 Apr 2012 by Tom Igoe
 */

//  Meghatározzuk, hány számot akarunk átlagolni.
// Nagyobb számnál simább lesz a kimenet,
// kisebbnél pedig a kimenet gyorsabban reagál.
// Integer állandót használunk a tömb elemeinek 
// számának meghatározására.

const int numReadings = 10;

// analóg bemenetet kiolvasó integer változó tömb:
int readings[numReadings];    
// aktuális kiolvasás értékét tároló integer változó:  
int index = 0;                  

int total = 0;                  // összes lefutás
int average = 0;                // az átlag

int inputPin = A0;

void setup() {
  // inicializáljuk a soros kommunikációt:
  Serial.begin(9600);                   
  // inicializáljuk a kiolvasást minden egyes kiolvasáshoz:
  for (int thisReading = 0; thisReading < numReadings; thisReading++)
    readings[thisReading] = 0;          
}

void loop() {
  // levonjuk az utolsó kiolvasást:
  total= total - readings[index];         
  // amit a szenzorból olvastunk ki:
  readings[index] = analogRead(inputPin); 
  // a kiolvasott értéket hozzáadjuk az egészhez:
  total= total + readings[index];       
  // továbblépünk a tömb következő eleméhez:
  index = index + 1;                    

  // ha a tömb végére érünk...
  if (index >= numReadings)              
    // ...visszaugrunk a kezdő értékhez:
    index = 0;                           

  // kiszámoljuk az átlagot:
  average = total / numReadings;         
  // a számítógépre küldjük ASCII számjegyként
  Serial.println(average);   
  delay(1);        
  // szünet a kiolvasások között a stabilitás miatt
}


